apiVersion: v1
kind: Secret
metadata:
  name: {{ grafana_name }}
  namespace: {{ namespace }}
stringData:
  grafana.ini: |
    app_mode = production
    instance_name = {{ grafana_name }}
    force_migration = true

    [log]
    mode = console

    [log.console]
{% if do_debugs %}
    level = debug
{% else %}
    level = info
{% endif %}
    format = console

    [security]
    admin_user = {{ grafana_admin_user }}
    admin_password = {{ grafana_admin_password }}
{% if grafana_do_ldap %}

    [auth.ldap]
    enabled = true
    config_file = /etc/grafana/ldap.toml
    allow_sign_up = true
{% endif %}
{% if grafana_do_lemon %}

    [auth.generic_oauth]
    name = LLNG
    enabled = true
    allow_sign_up = true
    client_id = grafana
    client_secret = {{ ldap_secret.resources[0].data['grafana-oauth2-secret'] | b64decode }}
    scopes = openid email profile
    email_attribute_name = email
    api_url = {{ lemon_portal }}/oauth2/userinfo
    auth_url = {{ lemon_portal }}/oauth2/authorize
    token_url = {{ lemon_portal }}/oauth2/token
    allowed_domains = {{ root_domain }}
    send_client_credentials_via_post = false
{% if k8s_flavor != 'openshift' and tls_provider == 'internalca' %}
    tls_skip_verify_insecure = false
{% else %}
    tls_skip_verify_insecure = true
{% endif %}
    tls_client_cert =
    tls_client_key =
{% if k8s_flavor != 'openshift' and tls_provider == 'internalca' %}
    tls_client_ca = /certs/ca.crt
{% else %}
    tls_client_ca =
{% endif %}
{% elif grafana_do_oc %}

    [auth.basic]
    enabled = false

    [auth.proxy]
    enabled = true
    header_name = X-Forwarded-User
    header_property = username
    auto_sign_up = true

    [auth.generic_oauth]
    name = OpenShift
    enabled = false
    allow_sign_up = true
    client_id = system:serviceaccount:{{ namespace }}:{{ grafana_name }}
    client_secret = $__file{/var/run/secrets/kubernetes.io/serviceaccount/token}
    scopes = user:info
    email_attribute_name = email
    api_url = https://{{ oc_api_fqdn | default('console.example.com') }}/oapi/v1/users
    auth_url = https://kubernetes.default.svc/oauth/authorize
    token_url = https://kubernetes.default.svc/oauth/token
    allowed_domains = {{ root_domain }}
    send_client_credentials_via_post = false
    tls_skip_verify_insecure = false
    tls_client_cert = /etc/tls/private/tls.crt
    tls_client_key = /etc/tls/private/tls.key
    tls_client_ca = /var/run/secrets/kubernetes.io/serviceaccount/ca.crt
{% endif %}

    [auth.anonymous]
{% if grafana_is_public | default(False) %}
    enabled = true
{% else %}
    enabled = false
{% endif %}
    org_role = Viewer

    [server]
    domain = {{ root_domain }}
    root_url = https://{{ grafana_fqdn }}

    [smtp]
{% if smtp_relay | default(False) %}
    enabled = true
    host = {{ smtp_relay }}
{% elif smtp_address | default(False) %}
    enabled = true
    host = {{ smtp_address | urlsplit('hostname') }}
{% else %}
    enabled = false
{% endif %}
    from_address = grafana@{{ root_domain }}
    from_name = Grafana
    skip_verify = true
    startTLS_policy = NoStartTLS

    [users]
    allow_sign_up = false
    default_theme = dark

    [database]
{% if grafana_db_type in [ 'mariadb', 'mysql' ] %}
    type = mysql
    host = {{ gfnms_name }}:3306
    name = {{ gfnms_db_name }}
    user = {{ gfnms_username }}
    password = {{ gfnms_password }}
{% elif grafana_db_type == 'postgres' %}
    type = postgres
    host = {{ gfnpg_name }}:5432
    name = {{ gfnpg_db_name }}
    user = {{ gfnpg_username }}
    password = {{ gfnpg_password }}
    max_idle_conn = 2
    max_open_conn = 10
{% else %}
    type = sqlite3
    path = grafana.db
{% endif %}

    [session]
{% if grafana_sessions_type == 'redis' %}
    provider = redis
    provider_config = addr={{ gfnrds_host }}-proxy:6379,pool_size={{ redis_pool_size | default(100) }},db={{ redis_db | default(0) }}
{% endif %}
    cookie_name = grafana_sess
    cookie_secure = true
  ops-dashboards.yaml: |
    apiVersion: 1
    providers:
    - name: Opsperator
{% if grafana_is_readonly | default(False) and not do_debugs %}
      allowUiUpdates: false
      disableDeletion: true
      editable: false
{% else %}
      allowUiUpdates: true
      disableDeletion: false
      editable: true
{% endif %}
      folder: ''
      options:
        path: /ops-dashboards
      orgId: 1
      type: file
      updateIntervalSeconds: 0
{% if grafana_do_ldap %}
  ldap.toml: |
    [[servers]]
{% if ldaps_address | default(False) %}
    host = "{{ ldaps_address | urlsplit('hostname') }}"
    port = {{ ldaps_address | urlsplit('port') }}
{% if skip_ldap_verify | default(False) %}
    ssl_skip_verify = true
{% else %}
    root_ca_cert = "/certs/ca.crt"
    ssl_skip_verify = false
{% endif %}
    start_tls = false
    use_ssl = true
{% else %}
    host = "{{ ldap_address | urlsplit('hostname') }}"
    port = {{ ldap_address | urlsplit('port') }}
    use_ssl = false
    start_tls = false
{% endif %}
    bind_dn = "cn=grafana,ou=services,{{ ldap_secret.resources[0].data['directory-root'] | b64decode }}"
    bind_password = '{{ ldap_secret.resources[0].data['grafana-password'] | b64decode }}'
{% if grafana_do_lemon %}
    search_filter = "(&(uid=%s)(objectClass=wsweetUser)(!(pwdAccountLockedTime=*)))"
{% elif grafana_do_fusion %}
    search_filter = "(&(uid=%s)(objectClass=gosaAccount)(!(pwdAccountLockedTime=*)))"
{% else %}
    search_filter = "(&(uid=%s)(objectClass={{ grafana_ldap_user_objectclass }})(!(pwdAccountLockedTime=*)))"
{% endif %}
    search_base_dns = ["ou=users,{{ ldap_secret.resources[0].data['directory-root'] | b64decode }}"]
{% if grafana_do_lemon %}
    #?? group_search_filter = "(&(objectClass=wsweetGroupMailingList)(memberUid=%s))"
{% elif grafana_do_fusion %}
    #?? group_search_filter = "(&(objectClass=gosaGroupOfNames)(memberUid=%s))"
{% else %}
    #?? group_search_filter = "(&(objectClass={{ grafana_ldap_group_objectclass }})(memberUid=%s))"
{% endif %}
    group_search_filter_user_attribute = "member"
    group_search_base_dns = ["ou=groups,{{ ldap_secret.resources[0].data['directory-root'] | b64decode }}"]
    [servers.attributes]
    name = "givenName"
    surname = "sn"
    username = "uid"
    member_of = "memberOf"
    email = "email"
{% endif %}
  prometheus.yaml: |
    apiVersion: 1
    datasources:
    - access: proxy
      isDefault: true
      name: Prometheus
      type: prometheus
      url: {{ grafana_upstream }}
    deleteDatasources: []
